/*
 * *************************************************
 * Copyright (c) 2018 QMTH. All Rights Reserved.
 * Created by Deason on 2018-10-17 17:16:01.
 * *************************************************
 */

package cn.com.qmth.examcloud.core.print.test;

import cn.com.qmth.examcloud.core.print.PrintApplication;
import cn.com.qmth.examcloud.core.print.common.jpa.OrderBuilder;
import cn.com.qmth.examcloud.core.print.common.jpa.SearchBuilder;
import cn.com.qmth.examcloud.core.print.common.jpa.SpecUtils;
import cn.com.qmth.examcloud.core.print.common.utils.JsonMapper;
import cn.com.qmth.examcloud.core.print.entity.PrintingProject;
import cn.com.qmth.examcloud.core.print.repository.PrintingProjectRepository;
import cn.com.qmth.examcloud.core.print.service.PrintingProjectService;
import org.junit.Test;
import org.junit.runner.RunWith;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.context.SpringBootTest;
import org.springframework.data.jpa.domain.Specification;
import org.springframework.test.context.junit4.SpringRunner;

import java.util.List;

/**
 * @author: fengdesheng
 * @since: 2018/10/17
 */
@RunWith(SpringRunner.class)
@SpringBootTest(classes = PrintApplication.class)
public class PrintingProjectServiceTest {
    @Autowired
    private PrintingProjectService printingProjectService;
    @Autowired
    private PrintingProjectRepository printingProjectRepository;

    @Test
    public void demoTest() throws Exception {
        //查询条件1
        SearchBuilder searchBuilder1 = new SearchBuilder().eq("orgName", "abc");
        Specification<PrintingProject> spec1 = SpecUtils.buildSearchers(PrintingProject.class, searchBuilder1.build());

        //查询条件2
        SearchBuilder searchBuilder2 = new SearchBuilder().eq("orgId", 1L).eq("examId", 1L);
        Specification<PrintingProject> spec2 = SpecUtils.buildSearchers(PrintingProject.class, searchBuilder2.build(), true);

        //合并查询条件
        //Specification<PrintingProject> spec = SpecUtils.orMerge(spec1, spec2);
        //Specification<PrintingProject> spec = SpecUtils.andMerge(spec1, spec2);
        Specification<PrintingProject> spec = SearchBuilder.EQ("orgId", 1L);

        OrderBuilder orderBuilder = new OrderBuilder().desc("id");
        List<PrintingProject> list = printingProjectRepository.findAll(spec, orderBuilder.build());
        System.out.println(new JsonMapper().toJson(list));
    }

}